import * as jwt from "jsonwebtoken";

import { HttpController } from "../http-controller";

import Log from "../../libs/log";

export class ExampleController extends HttpController {
  private _log: Log;

  constructor() {
    super();
    this._log = Log.instance;
  }

  public index = async () => {
    try {
      this.success({ status: "OK", statusCode: 200, payload: {} });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      this.error({ error: err.message, status: "NO_OK", statusCode: 422 });
    }
  };

  public getToken = () => {
    const token = jwt.sign({ data: "example data" }, process.env.SECRET, {
      expiresIn: "24h"
    });
    this.success({ status: "OK", statusCode: 200, payload: { token } });
  };

  public protectedMethod = () => {
    this.success({
      status: "OK",
      statusCode: 200,
      payload: { message: "This is a protected method" }
    });
  };
}
