import { Response } from "../http-petition";
import { HttpResourceController } from "../http-resource-controller";

import Log from "../../libs/log";

export class ExampleResourceController extends HttpResourceController {
  private _log: Log;

  constructor() {
    super();
    this._log = Log.instance;
  }

  public async index(): Promise<Response> {
    try {
      const items = new Array<any>(); // await this.modules.database("table").select("*");

      return this.success({ status: "OK", statusCode: 200, payload: items });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      return this.error({
        error: err.message,
        status: "NO_OK",
        statusCode: 422
      });
    }
  }

  public async store(): Promise<Response> {
    try {
      const item = this.petition.response.payload;
      const id = 0; // await this.modules.database("table").insert(item);

      return this.success({
        status: "OK",
        statusCode: 200,
        payload: { id, message: "inserted" }
      });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      return this.error({
        error: err.message,
        status: "NO_OK",
        statusCode: 422
      });
    }
  }

  public async show(): Promise<Response> {
    try {
      const id = this.petition.request.params.id;
      const item = { id };
      return this.success({
        status: "OK",
        statusCode: 200,
        payload: item || {}
      });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      return this.error({
        error: err.message,
        status: "NO_OK",
        statusCode: 422
      });
    }
  }

  public async update(): Promise<Response> {
    try {
      const item = this.petition.request.payload;
      const result = 0;

      return this.success({
        status: "OK",
        statusCode: 200,
        payload: { rowsAffected: result }
      });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      return this.error({
        error: err.message,
        status: "NO_OK",
        statusCode: 422
      });
    }
  }

  public async destroy(): Promise<Response> {
    try {
      const id = this.petition.request.params.id;
      const result = 0;

      return this.success({
        status: "OK",
        statusCode: 200,
        payload: { rowsAffected: result }
      });
    } catch (err) {
      this._log.logger.error("Ocurrió un error", err.message);
      return this.error({
        error: err.message,
        status: "NO_OK",
        statusCode: 422
      });
    }
  }
}
