import { Petition, Request, Response } from "./http-petition";

export class HttpController {
  private _petition: Petition;

  constructor(petition?: Petition) {
    this._petition = petition;
  }

  public get petition() {
    return this._petition;
  }

  public set petition(petition: Petition) {
    this._petition = petition;
  }

  public get request(): Request {
    return this._petition.request;
  }

  public get response(): Response {
    return this._petition.response;
  }

  public success(
    response = { status: "OK", statusCode: 200, payload: {} }
  ): Response {
    this._petition.response.status = response.status;
    this._petition.response.statusCode = response.statusCode;
    this._petition.response.payload = response.payload;

    return {
      headers: this._petition.response.headers,
      status: this._petition.response.status,
      statusCode: this._petition.response.statusCode,
      payload: this._petition.response.payload
    };
  }

  public error(
    response = { status: "NO_OK", statusCode: 500, error: "" }
  ): Response {
    this._petition.response.status = response.status;
    this._petition.response.statusCode = response.statusCode;
    this._petition.response.error = response.error;

    return {
      status: this._petition.response.status,
      statusCode: this._petition.response.statusCode,
      error: this._petition.response.error
    };
  }
}
