import { Op } from "sequelize";

import Db from "..";
import { Chileautos } from "../../../entities";

export default class ExtrDb {
  private _db: Db;
  private _tableName: string;

  constructor(db: Db, tableName: string) {
    this._db = db;
    this._tableName = tableName;

    this._db.defineModel(this._tableName);
  }

  public async getByCode(code: string): Promise<Chileautos> {
    const result = await this._db.models().extrs.findOne({ where: { code } });
    if (!result) {
      return null;
    }

    return { code, ...result.get() };
  }

  public async getAll(): Promise<Array<any>> {
    const result = await this._db.models().extrs.findAll();
    if (!result) {
      return null;
    }

    return result;
  }

  public async getFilteredBy({id = 0, authorId = 0}: any): Promise<Array<any>> {
    const where: any = { };

    if (id !== 0) {
      where.id = {
        [Op.eq]: id
      };
    }

    if (authorId !== 0) {
      where.authorId = {
        [Op.eq]: authorId
      };
    }

    const result = await this._db.models().extrs.findAll({ where });
    if (!result) {
      return null;
    }

    return result;
  }
}
