export default class RandomDie {
  private _numSides: number;

  constructor(numSides: number) {
    this._numSides = numSides;
  }

  public get numSides(): number {
    return this._numSides;
  }

  public rollOnce(): any {
    return 1 + Math.floor(Math.random() * this.numSides);
  }

  public roll({numRolls}: any): Array<number> {
    const output = new Array<number>();
    for (let i = 0; i < numRolls; i++) {
      output.push(this.rollOnce());
    }
    return output;
  }
}