import { GraphQLSchema, GraphQLObjectType, GraphQLString } from "graphql";
import Db from "../../data-storage/db";
import ExtrDb from "../../data-storage/db/extr";

import { Chileautos } from "../../entities";

import { allExtr, getExtr } from "../../use-cases/extr";

const schema = new GraphQLSchema({
  query: new GraphQLObjectType({
    name: "Query",
    fields: {
      code: {
        type: GraphQLString,
        resolve(rootValue) {
          return "Hello World";
        }
      }
    }
  })
})
// (`
//   type RandomDie {
//     numSides: Int!
//     rollOnce: Int!
//     roll(numRolls: Int!): [Int]
//   }

//   type Extr {
//     year: Int!
//     maker: String!
//     model: String!
//     version: String
//     color: String
//     price: Float!
//     title: String!
//     description: String
//     plate: String
//     mileage: Float
//     gearbox: String
//     engine: String
//     fuel: String
//     imageUrl: String
//     code: String!
//     url: String!
//     region: String
//     city: String
//     sellerType: String
//     sellerName: String
//     publicationCreationDate: String!
//     publicationUpdateDate: String!
//     publicationCreatedAt: String!
//   }

//   type Query {
//     hello: String
//     rollDice(numDice: Int!, numSides: Int): [Int]
//     getExtrs(code: String): [Extr]
//     getExtr(code: String): Extr
//   }
// `);

const tblName = "chileautos";

const db = new Db();
const extrDb = new ExtrDb(db, tblName);

const root = {
  hello: () => "hello",
  rollDice: (args: any) => {
    const output = [];
    for (let i = 0; i < args.numDice; i++) {
      output.push(1 + Math.floor(Math.random() * (args.numSides || 6)));
    }
    return output;
  },
  getExtrs: ({ code }: any) => {
    return code ? allExtr.filteredBy({ code }, extrDb) : allExtr.get(extrDb);
  },
  getExtr: ({ id }: any) => {
    return getExtr.byCode(id, extrDb);
  }
};

export { schema, root };