import * as path from "path";
import * as swaggerUI from "swagger-ui-express";
import * as swaggerJsDoc from "swagger-jsdoc";

const options = {
  definition: {
    openapi: "3.0.0",
    info: {
      title: "Express RESTful API",
      version: "1.0.0",
      description: "A simple Express RESTful API",
      contact: {
        name: "API Support",
        url: "https://pablo.by/contacto/",
        email: "contacto@pablo.by"
      }
    },
    servers: [
      {
        url: `http://localhost:${process.env.PORT}`,
        description: "RESTful API Documentation"
      }
    ]
  },
  apis: [path.join(__dirname, "../../docs/**/*.yml")]
};

const swaggerSpec = swaggerJsDoc(options);
const swaggerUIServe = swaggerUI.serve;
const swaggerUISetup = swaggerUI.setup(swaggerSpec);

export { swaggerUIServe, swaggerUISetup };
