import { Post } from "../../entities";
import Add from "../../use-cases/post/add";
import FakeDb from "../../data-storage/fake-db";
import FakePostDb from "../../data-storage/fake-db/post";

describe("Se intentará agregar un nuevo post", () => {
  test("Agregar un nuevo post", () => {
    const add = new Add();
    const fakeDb = new FakeDb();
    const fakePostDb = new FakePostDb(fakeDb);
    const newPost = new Post();
    newPost.authorId = 1;
    newPost.title = "Test title";
    newPost.body = "Test body";
    return add.save(newPost, fakePostDb).then(data => {
      expect(data).toHaveProperty("_id");
    });
  });
});
