import { Post } from "../../entities";
import Update from "../../use-cases/post/update";
import FakeDb from "../../data-storage/fake-db";
import FakePostDb from "../../data-storage/fake-db/post";
import { randomInt } from "crypto";

describe("Se intentará actualizar un nuevo post", () => {
  test("Actualizar un nuevo post", () => {
    const update = new Update();
    const fakeDb = new FakeDb();
    const fakePostDb = new FakePostDb(fakeDb);
    const postData = {
      id: randomInt(9999),
      title: "Test title",
      body: "Test body",
      authorId: 1,
      published: false
    };
    const newPost = new Post();
    newPost.title = postData.title;
    newPost.body = postData.body;
    return update.save(newPost, postData, fakePostDb).then(data => {
      expect(data).toBeTruthy();
    });
  });
});
