import Mailer from "../libs/mailer";
import { EmailParams } from "../libs/mailer/params-interface";

describe("Se intenta enviar un email", () => {
  test("Se enviará un email", async () => {
    const mailer = new Mailer();
    const emailParms: EmailParams = {
      from: "contacto@pablo.by",
      html: "<p>Email de prueba</p>",
      subject: "Email de prueba",
      to: ["contacto@pablo.by"]
    };
    const result = await mailer.sendEmail(emailParms).catch(err => {
      console.error(err.message);
    });
    expect(result.response.toString()).toMatch(/Ok/);
  });

  // Hack
  // https://github.com/visionmedia/supertest/issues/520#issuecomment-469044925
  afterAll(async () => {
    await new Promise(resolve => setTimeout(() => resolve(null), 2000)); // avoid jest open handle error
  });
});
