import * as request from "supertest";
import ExpressApp from "../frameworks/express/express-app";

describe("Comprueba si las rutas sin accesibles a través de las interfaces Web y API", () => {
  const expressApp = ExpressApp.instance;

  test("Obtiene el estado del Servidor vía interfaz Web", async () => {
    const response = await request(expressApp).get("/status");
    expect(response.status).toEqual(200);
    expect(response.text).toBe("OK");
  });

  test("Obtiene el estado del Servidor via interfaz API", async () => {
    const response = await request(expressApp).get("/api/status");

    expect(response.headers["content-type"]).toMatch(/json/);
    expect(response.status).toEqual(200);
    expect(response.body).toBe("OK");
  });

  // Hack
  // https://github.com/visionmedia/supertest/issues/520#issuecomment-469044925
  afterAll(async () => {
    await new Promise(resolve => setTimeout(() => resolve(null), 500)); // avoid jest open handle error
  });
});
