import { Chileautos } from "../../entities/extr";

import ExtrDb from "../../data-storage/db/extr";

export default class All {
  private _db: ExtrDb;

  public async get(db: ExtrDb): Promise<Array<Chileautos>> {
    this._db = db;
    return this.build(await this._db.getAll());
  }

  public async filteredBy({code = ''}, db: ExtrDb): Promise<Array<Chileautos>> {
    return this.build(await this._db.getFilteredBy({code}));
  }

  private build(
    postsData: Array<{
      id?: number;
      title: string;
      body: string;
      author?: Author;
      authorId: number;
      published: boolean;
      createdAt: number;
      updatedAt: number;
    }>
  ): Array<Chileautos> {
    if (!postsData) {
      throw new Error("No posts found");
    }

    return postsData.map(postData => {
      const post = new Chileautos();
      post.id = postData.id || 0;
      post.title = postData.title || "";
      post.body = postData.body || "";
      post.author = postData.author || null;
      post.authorId = postData.authorId || 0;
      post.published = postData.published || false;
      post.createdAt = postData.createdAt;
      post.updatedAt = postData.updatedAt;

      return post;
    });
  }
}
